---
policy: /ce/ca/aws/sagemaker/endpoint-config-encryption-with-kms
logic: /ce/ca/aws/sagemaker/endpoint-config-encryption-with-kms/prod.logic.yaml
executionTime: 2025-11-17T14:33:46.264215169Z
generationMs: 54
executionMs: 654
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10A1__disappearanceTime__c)
      actual: isDisappeared(CA10A1__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10A1__kmsKeyId__c').isEmpty()
      actual: extract('CA10A1__kmsKeyId__c').isEmpty()
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 200
      actual: 200
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/sagemaker/endpoint-config-encryption-with-kms/policy.yaml
    md5Hash: FC955743911B136EC0BB5EC06A0B7169
    content: "---\nnames:\n  full: \"AWS SageMaker Endpoint Config does not specify\
      \ a KMS key\"\n  contextual: \"Endpoint Config does not specify a KMS key\"\n\
      description: >\n  Ensure that AWS SageMaker Endpoint Configurations utilize\
      \ customer-managed AWS KMS keys. \n  This provides an additional layer of security\
      \ for the data stored on the endpoint's storage volume.\ntype: \"COMPLIANCE_POLICY\"\
      \ncategories:\n  - \"SECURITY\"\nframeworkMappings:\n  - \"/frameworks/cloudaware/resource-security/data-encryption\"\
      \n  - \"/frameworks/aws-well-architected/sec/08/02\"\nsimilarPolicies:\n  cloudConformity:\n\
      \    - url: \"https://www.trendmicro.com/cloudoneconformity/knowledge-base/aws/SageMaker/endpoint-encrypted-with-cmk.html\"\
      \n      name: \"Endpoints Encrypted With KMS Customer Managed Keys\""
  - path: /ce/ca/aws/sagemaker/endpoint-config-encryption-with-kms/prod.logic.yaml
    md5Hash: C55D513AAA010CE682ADDCD132F4E7CE
    content: |-
      ---
      inputType: "CA10A1__CaAwsSageMakerEndpointConfig__c"
      testData:
        - file: "test-data.json"
      importExtracts:
        - file: "/types/CA10A1__CaAwsSageMakerEndpointConfig__c/object.extracts.yaml"
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "KMS key is not specified for the SageMaker endpoint configuration."
          remediationMessage: "Specify a KMS key for the endpoint configuration to encrypt data on the storage volume."
          check:
            IS_EMPTY:
              arg:
                EXTRACT: "CA10A1__kmsKeyId__c"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "The SageMaker Endpoint Config utilizes a KMS key."
  - path: /ce/ca/aws/sagemaker/endpoint-config-encryption-with-kms/test-data.json
    md5Hash: F094966C342DD7C8B311DDBF1FEA21D6
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10A1__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-06T13:49:55Z"
              },
              "CA10A1__disappearanceTime__c": "2025-10-31T19:08:10Z",
              "CA10A1__kmsKeyId__c": "kmsKeyId",
              "Id": "test1"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10A1__kmsKeyId__c').isEmpty()",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-06T13:49:55Z"
              },
              "CA10A1__disappearanceTime__c": null,
              "CA10A1__kmsKeyId__c": "",
              "Id": "test2"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "200",
                  "conditionText": "otherwise",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2025-11-06T13:49:55Z"
              },
              "CA10A1__disappearanceTime__c": null,
              "CA10A1__kmsKeyId__c": "kmsKeyId",
              "Id": "test3"
          }
      ]
  - path: /types/CA10A1__CaAwsSageMakerEndpointConfig__c/object.extracts.yaml
    md5Hash: C6F0D4A686EFEF1E2A921D3320C16FA4
    content: "---\nextracts:\n# Nullable.\n  - name: CA10A1__kmsKeyId__c\n    value:\n\
      \      FIELD: \n        path: CA10A1__kmsKeyId__c\n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10A1__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10A1__kmsKeyId__c').isEmpty()",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "200",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10A1__CaAwsSageMakerEndpointConfig__c()
  RETURNS ARRAY<STRUCT<
      CA10A1__disappearanceTime__c TIMESTAMP,
      CA10A1__kmsKeyId__c STRING,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-11-06T13:49:55Z")
    },
    "CA10A1__disappearanceTime__c" : new Date("2025-10-31T19:08:10Z"),
    "CA10A1__kmsKeyId__c" : "kmsKeyId",
    "Id" : "test1"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-11-06T13:49:55Z")
    },
    "CA10A1__kmsKeyId__c" : "",
    "Id" : "test2"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-11-06T13:49:55Z")
    },
    "CA10A1__kmsKeyId__c" : "kmsKeyId",
    "Id" : "test3"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10A1__CaAwsSageMakerEndpointConfig__c(
      obj STRUCT<
          CA10A1__disappearanceTime__c TIMESTAMP,
          CA10A1__kmsKeyId__c STRING,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10A1__disappearanceTime__c]: ' + obj.CA10A1__disappearanceTime__c);
      if (obj.CA10A1__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10A1__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10A1__kmsKeyId__c; } return this.out; };
      references1.push('KMS Key ID [obj.CA10A1__kmsKeyId__c]: ' + obj.CA10A1__kmsKeyId__c);
      if (TextLib.isEmpty(extract3.call(extract3))) {
          return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10A1__kmsKeyId__c').isEmpty()", currentStateMessage: "KMS key is not specified for the SageMaker endpoint configuration.", currentStateReferences: references1.join('\n'), remediation: "Specify a KMS key for the endpoint configuration to encrypt data on the storage volume.", runtimeError: null};
      }
      return {status: 'COMPLIANT', conditionIndex: 200, conditionText: "otherwise", currentStateMessage: "The SageMaker Endpoint Config utilizes a KMS key.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10A1__disappearanceTime__c AS CA10A1__disappearanceTime__c,
          sObject.CA10A1__kmsKeyId__c AS CA10A1__kmsKeyId__c,
          sObject.Id AS Id,
          process_CA10A1__CaAwsSageMakerEndpointConfig__c(
              STRUCT(
                  sObject.CA10A1__disappearanceTime__c AS CA10A1__disappearanceTime__c,
                  sObject.CA10A1__kmsKeyId__c AS CA10A1__kmsKeyId__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10A1__CaAwsSageMakerEndpointConfig__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
